VERSION 8000;;8407
* Allg_BspDialogErweitert.CSX  Dialog mit Abhngigkeiten  29.11.11
* -----------------------------------------------------------------------------
* @filedoc
* @file Allg_BspDialogErweitert.CSX
* @brief Dialog mit Abhngigkeiten 
* 
* Dialog mit:
* * Einfaches Feld fr ganzzahligen Wert
* * Textfeld mit einem von der Zahl abhngigen Text
* * Checkbox, die Textfeld aktiv oder passiv schaltet
* * Button zum zurcksetzen der Feldinhalte
*
* -----------------------------------------------------------------------------
* Copyright (C) IB&T
* 
* Gewhrleistung und Nutzung
* 
* Die Nutzung des Skriptes erfolgt stets auf eigene Gefahr. IB&T bernimmt keine
* Gewhr dafr, dass die Nutzung dieses Skriptes zu Ihrem gewnschten Ergebnis
* fhrt. Da CardScripte vorhandene Projektdaten durch Direktzugriff auf die
* jeweiligen Datenbanken auch ohne weitere Sicherheitsabfragen unbemerkt verndern
* oder lschen knnen, erfordert eine Nutzung entsprechende Kenntnisse und groe
* Sorgfalt. IB&T haftet nicht fr eventuell entstehende Datenverluste und
* Folgeschden, die durch die Nutzung von CardScripten entstehen.
*
* -----------------------------------------------------------------------------
* @author HB
* @endfiledoc
* -----------------------------------------------------------------------------
* @history
* -----------------------------------------------------------------------------
* 
BILDSCHIRM GRAFIK
*
SYMBOLE /DLG_WINDOW/ Dialog
SYMBOLE /DLG_NUMBER/ ZahlFeld
SYMBOLE /DLG_TEXT/ TextFeld
SYMBOLE /DLG_CHECKBOX/ TextCheck
SYMBOLE /DLG_BUTTON/ Reset

SYMBOLE /MY_ZAHLINFO/ ZahlInfo
SYMBOLE * Zahl; !Text; Check; !Text2
SYMBOLE * Ret; Run; Test; StartFeld

*...................Inhalte vorbelegen
Zahl = 123
!Text = "Text"
Check = 1        | Textfeld aktiv

*..................Dialog anlegen
Dialog = NewObject /DLG_WINDOW/
Dialog.SetCaption("Dialog")
*...................Feld fr Wert 
ZahlFeld = NewObject /DLG_NUMBER/
ZahlFeld.SetLabel("Wert:")
ZahlFeld.SetSize(5)
ZahlFeld.SetValue(Zahl)
Dialog.AddField(ZahlFeld)
*...................Feld fr Wertinfo
ZahlInfo  = NewObject /MY_ZAHLINFO/
ZahlInfo.Ini(ZahlFeld)
Dialog.AddField(ZahlInfo)
*...................Feld fr Checkbox
TextCheck= NewObject /DLG_CHECKBOX/
TextCheck.SetBoxLabel("Text:")
TextCheck.SetValue(Check)
Dialog.AddField(TextCheck)
*...................Feld fr Text
TextFeld = NewObject /DLG_TEXT/
TextFeld.SetText(!Text)
TextFeld.AddObserveField(TextCheck; 1; 1) | aktiv wenn Prfwert == 1
Dialog.AddField(TextFeld)

*...................Button
Reset = NewObject /DLG_BUTTON/
Reset.SetCaption("Zurcksetzen")
Reset.SetId(10001) 
Dialog.AddButton(Reset)

*....................Dialogschleife
StartFeld = 1
Run = 1
SOLANGE Test = Run
  Run = 0
  Ret = Dialog.DoDialog(StartFeld )
  VERZWEIGE Ret
  ZWEIG 1      |..............Werte prfen
    !Text2 = TextFeld.GetText()
    WENN T_Lang(!Text2) == 0 DANN
      Meldung FEHLER "Text ist leer!"
      StartFeld = 4
      Run = 1
    WEITER  
  ZWEIG 10001  |..............Zurcksetzen
    ZahlFeld.SetValue(123)
    TextFeld.SetText("Testtext")
    ZahlInfo.Update()  
    Run = 1
  ENDE VERZWEIGE
ENDE SOLANGE  
*....................Ergebnis
WENN Ret DANN
  !Text = TextFeld.GetText()
  Zahl = ZahlFeld.GetValue()
  Melde "Ergebnis: # #";Zahl; !Text 
WEITER
STOP
* -----------------------------------------------------------------------------
* @class /MY_ZAHLINFO/
* @brief Hilfsklasse zum Beobachten eines Zahlenfeldes
* @author HB
* @endclass
KLASSE /MY_ZAHLINFO/; /DLG_TEXT/
  SYMBOLE /DLG_NUMBER/ m_Number
  * -----------------------------------------------------------------------------
  * @function Ini
  * @brief Initialisieren des Objkets
  * @param Number: Feld, das beobachtet werden soll
  * @author HB
  * @endfunction
  FUNKTION Ini: {/DLG_NUMBER/} Number
    m_Number = Number
    AddObserveField(Number)   | zur Beobachtung anmelden
    SetActive(0)              | passiv anzeigen
    SetSize(30)               | Feldgre
    AppendRight()             | rechts anhngen
    Update()
  ENDE FUNKTION 
  * -----------------------------------------------------------------------------
  * @function NotifyField
  * @brief nderungsnachricht auswerten
  * Diese Methode wird vom Dialogsystem aufgerufen. 
  * @param Feld: gendertes Feld
  * @return {long}
  * @retval = 1: Ok
  * @author HB
  * @endfunction
  FUNKTION {long} NotifyField: {/DLG_FIELD/} Feld
    Symbole * Wert
    WENN Feld.CheckField(m_Number) DANN
      Update()                | Wert aktualisieren
    WEITER
    Zurck 1
  ENDE FUNKTION 
  * -----------------------------------------------------------------------------
  * @function Update
  * @brief Eigenen Inhalt aktualisieren
  * @author HB
  * @endfunction
  FUNKTION Update:
    Symbole * Wert
    Wert = m_Number.GetValue()
    WENN Wert > 100 DANN
      SetText("groer Wert")
    SONST
      SetText("kleiner Wert")
    WEITER
  ENDE FUNKTION 
  * -----------------------------------------------------------------------------
ENDE KLASSE  
* -----------------------------------------------------------------------------
 

