VERSION 8; ; 8409
* Dgm_Punkte_DeltaH_CSV.CSX                             29.02.2012
* -----------------------------------------------------------------------------
* @filedoc
* @file Dgm_Punkte_DeltaH_CSV.CSX
* @brief Hhendifferenz markierte Punkte vs. DGM
* 
*  Mit dem Skript berechnen Sie die Hhendifferenz zwischen markierten Punkten 
*  und einem DGM. Die Ergebnisse werden in eine CSV-Datei ausgegeben. 
*
* -----------------------------------------------------------------------------
* Copyright (C) IB&T
* 
* Gewhrleistung und Nutzung
* 
* Die Nutzung des Skriptes erfolgt stets auf eigene Gefahr. IB&T bernimmt keine
* Gewhr dafr, dass die Nutzung dieses Skriptes zu Ihrem gewnschten Ergebnis
* fhrt. Da CardScripte vorhandene Projektdaten durch Direktzugriff auf die
* jeweiligen Datenbanken auch ohne weitere Sicherheitsabfragen unbemerkt verndern
* oder lschen knnen, erfordert eine Nutzung entsprechende Kenntnisse und groe
* Sorgfalt. IB&T haftet nicht fr eventuell entstehende Datenverluste und
* Folgeschden, die durch die Nutzung von CardScripten entstehen.
*
* -----------------------------------------------------------------------------
* @author CK
* @endfiledoc
* -----------------------------------------------------------------------------
* @history
* -----------------------------------------------------------------------------

* Vereinbarungen -----------------------------------------------------------------------------

BILDSCHIRM GRAFIK                | gibt die Meldungen im Arbeitsprotokoll aus

* Deklarationen ------------------------------------------------------------------------------

SYMBOLE /DTMSYS/ DtmSys
SYMBOLE /DTM/ Dtm
SYMBOLE /PointSys/ PointSys
SYMBOLE /POINTINDEX/ PointIndex
SYMBOLE /Point/ Point
SYMBOLE * PMark;!DtmBezeichnung;!DtmName;!DatAusName;!DatAusBez;CheckWert1;!Ext; NPkt;FPkt

* Zuweisungen ---------------------------------------------------------------------------------
!DtmName = " "
!DtmBezeichnung = " " 
!DatAusName = "Test"
!DatAusBez = "Differenz Flche - gemessene Punkte"
!PN = " "
NPkt = 0
FPkt = 0
CheckWert1 = 0

* Ausfhrung --------------------------------------------------------------------------------------
* Dialog zur Auswahl des DGM und Eingabe des Dateinamens 
Dialog_Status = Dialog1()                            | Ausfhren der Dialogfunktion 
Wenn Dialog_Status == 0 DANN STOP  MELDE "Abbruch des Dialoges"

* ---------------------------------------------------------------------------------------------
DtmSys = Project.GetDtmSys()
Dtm = DtmSys.GetDtm(!DtmName)                        | liefert das DGM-Objekt
WENN Dtm==$NULL DANN STOP MELDE "Gelndemodell nicht gefunden --> Die Ausfhrung des Skripts wird beendet!"
!DtmBezeichnung = Dtm.GetDescription()
*
PointSys = Project.GetPointSys()                     | liefert das Objekt fr das System der Punkte
PointIndex = PointSys.GetPointIndex(1)               | liefert das Punktindexobjekt 
PointIndex.SetMarked(1)                              | Filter: nur markierte Punkte 
*
DAT_NEU 1;NAME=!DatAusName ; BEZ= !DatAusBez;Dez="POINT"         | Ergebnisdatei anlegen
WENN CheckWert1 = 0 DANN
  DAT_SCHREIBEN 1;"Punktnummer; DGM-Hhe; Punkthhe; Differenz"  | Ausgabe ohne Koordinaten
SONST
  DAT_SCHREIBEN 1;"Punktnummer; Rechtswert; Hochwert;  DGM-Hhe; Punkthhe; Differenz"  
WEITER
  
SOLANGE Point = PointIndex.GetNext()                             | Schleife ber alle markierten Punkte 
  !PN = Point.GetName()
  X = Point.GetX()
  Y = Point.GetY()
  Z = Point.GetZ()
  DgmHoehe = Dtm.GetHeight(X;Y)
  WENN CheckWert1 = 0 DANN                                       | Ausgabe ohne Koordinaten
    WENN DgmHoehe==$UNDEF DANN                                   | markierer Punkt auerhalb DGM     
      DAT_SCHREIBEN 1; "################; ;####.#### "; !PN; Z 
      FPkt = FPkt + 1
    SONST
      Differenz = Z - DgmHoehe
      DAT_SCHREIBEN 1; "################; ####.####; ####.####; ####.####"; !PN; DgmHoehe; Z; Differenz 
      NPkt = NPkt + 1
    WEITER
  SONST
    WENN DgmHoehe==$UNDEF DANN
      DAT_SCHREIBEN 1; "################; #######.###; #######.###; ;####.####   "; !PN; X;Y; Z 
      FPkt = FPkt + 1
    SONST
      Differenz = Z - DgmHoehe
      DAT_SCHREIBEN 1; "################; #######.###; #######.###; ####.####; ####.####; ####.####"; !PN;X;Y; DgmHoehe; Z; Differenz 
      NPkt = NPkt + 1
    WEITER
  WEITER    
ENDE SOLANGE 

MELDE "Gelndemodell: #, # "; !DtmName; !DtmBezeichnung
MELDE "Protokolldatei: # "; !DatAusName
MELDE "Hhendifferenzen fr # markierte Punkte berechnet"; NPkt
Wenn FPkt>0 Dann MELDE "Hhendifferenzen fr # markierte Punkte unbekannt"; FPkt

DAT_ZU 1                                            | Ergebnisdatei schlieen
* -------------------------------------------------------------------------------------------------
FUNKTION Dialog1:
  * Klassen fr Dialog und deren Felder 
  SYMBOLE /DLG_WINDOW/ Dialog      | Dialogfenster
  SYMBOLE /DLG_FRAME/ Rahmen1;Rahmen2
  SYMBOLE /DLG_FILENAME/ ExportDateiName
  SYMBOLE /DLG_COMBOBOX/ PunktHerkunft                                                                       |
  SYMBOLE /DLG_CHECKBOX/ Check1            | Checkbox
  SYMBOLE /DLG_DTM/ Dgm1                   | DGM-Auswahl
  SYMBOLE * Ret
  EXTERN  * !DatAusName;!DatAusBez;!DtmName;!DtmBezeichnung;CheckWert1
  
  Dialog = NewObject /DLG_WINDOW/                    | Anlegen des Dialogfensters
  Dialog.SetCaption("markierte Punkte - DGM: DeltaH in CSV-Datei ausgeben")      | berschrift des Fensters 
  Rahmen1 = Dialog.CreateFrame(0)
  Rahmen2 = Dialog.CreateFrame(0)
  
  * Auswahl DGM + Bezeichnung
  Dgm1 = NewObject /DLG_DTM/                         | Neues Feld fr DGM Auswahl erstellen            
  Dgm1.SetLabel("DGM:")                              | Text fr Dialog angeben 
  Dgm1.SetName(!DtmName)                             | Feld fr DGM-Namen
  Dgm1.SetDescription(!DtmBezeichnung)               | Feld fr DGM-Bezeichnung
  Rahmen1.AddField(Dgm1)                             | Feld zum Dialog zufgen
  * Eingabe Textfeld fr Ausgabedateiname
  ExportDateiName = NewObject /DLG_FILENAME/
  ExportDateiName.SetLabel("Ausgabedatei:")
  ExportDateiName.SetSize(40)
  ExportDateiName.SetPattern("*.csv")
  ExportDateiName.SetName(!DatAusName)
  ExportDateiName.SetDescription(!DatAusBez)
  ExportDateiName.EnableNew()
  ExportDateiName.FixExtension()
  Rahmen1.AddField(ExportDateiName)
  * Checkbox fr Ausgab der Koordinaten
  Check1 = NewObject /DLG_CHECKBOX/
  Check1.SetBoxLabel("Koordinaten in Datei mit ausgeben")
  Check1.SetFieldLabel(" ")
  Check1.SetValue(CheckWert1)  
  Rahmen2.AddField(Check1)
  
  * Dialog ausfhren
  Ret = Dialog.DoDialog()          | Dialog ausfhren
  
  *  Auswertung des Dialoges nach Besttigung durch OK oder Abbruch
  WENN Ret DANN
    !DtmName = Dgm1.GetName()
    !DtmBezeichnung = Dgm1.GetName()
    !DatAusName = ExportDateiName.GetName()
    !DatAusBez = ExportDateiName.GetDescription()
    CheckWert1= Check1.GetValue()
  WEITER
  ZURCK Ret
ENDE FUNKTION

*******************************************************************************************************************

