VERSION 8; ; 9114
* Dgm_Punkte_DeltaH.CSX                            29.02.2012 
* -----------------------------------------------------------------------------
* @filedoc
* @file Dgm_Punkte_DeltaH.CSX
* @brief Hhendifferenz markierte Punkte vs. DGM
* 
*  Mit dem Skript berechnen Sie die Hhendifferenz zwischen markierten Punkten 
*  und einem DGM. Die Ergebnisse werden in Nebenattribute zu Punktsymbolen ausgegeben. 
*
* -----------------------------------------------------------------------------
* Copyright (C) IB&T
* 
* Gewhrleistung und Nutzung
* 
* Die Nutzung des Skriptes erfolgt stets auf eigene Gefahr. IB&T bernimmt keine
* Gewhr dafr, dass die Nutzung dieses Skriptes zu Ihrem gewnschten Ergebnis
* fhrt. Da CardScripte vorhandene Projektdaten durch Direktzugriff auf die
* jeweiligen Datenbanken auch ohne weitere Sicherheitsabfragen unbemerkt verndern
* oder lschen knnen, erfordert eine Nutzung entsprechende Kenntnisse und groe
* Sorgfalt. IB&T haftet nicht fr eventuell entstehende Datenverluste und
* Folgeschden, die durch die Nutzung von CardScripten entstehen.
*
* -----------------------------------------------------------------------------
* @author CK
* @endfiledoc
* -----------------------------------------------------------------------------
*    9144 08.04.21 NR Umwandlung der Symbolkodes in alphanummeriasche Kodes
* @history
* -----------------------------------------------------------------------------

* Vereinbarungen --------------------------------------------------------------------------------

BILDSCHIRM GRAFIK                | gibt die Meldungen im Arbeitsprotokoll aus
$PRFSTUFE 7
* Deklarationen -----------------------------------------------------------------------------------
SYMBOLE /DTMSYS/ DtmSys
SYMBOLE /DTM/ Dtm
SYMBOLE /PointSys/ PointSys
SYMBOLE /POINTINDEX/ PointIndex
SYMBOLE /TOPOSYS/ Toposys
SYMBOLE /TOPOLAYER/ Schicht
SYMBOLE /TOPOSYMBOL/ PktSymbol 
SYMBOLE /Point/ Point
SYMBOLE /Coordinate/ Coordinate
SYMBOLE * Dialog_Status;!DtmName;!DtmBezeichnung;!Schicht;!Schichtbez;NPkt;FPkt;X;Y;Z;DgmHoehe;Differenz;!tdiff;!SK;SymNr;!PN   

* Systemobjekte
DtmSys = Project.GetDtmSys()
PointSys = Project.GetPointSys()                   | liefert das Objekt fr das System der Punkte
PointIndex = PointSys.GetPointIndex(1)             | liefert das Punktindexobjekt 
Toposys = Project.GetToposys()

* Vorbelegungen
!DtmName = " "
!DtmBezeichnung = " " 
!Schicht = " "
!Schichtbez = " "
NPkt = 0
FPkt = 0
SymNr = 0
!SK = "0"

* Ausfhrung -------------------------------------------------------------------------------------------------
* Dialog zur Auswahl des DGM und Eingabe des Dateinamens 
Dialog_Status = Dialog1()                        | Aufruf des Dialoges 
WENN Dialog_Status == 0 DANN STOP  MELDE "Abbruch des Dialoges"
*
Schicht = TopoSys.GetLayerByName(!Schicht) | Schicht fr Hhendifferenzen - Texte

* Gelndemodell whlen
Dtm = DtmSys.GetDtm(!DtmName)                      | liefert das DGM-Objekt
WENN Dtm==$NULL DANN STOP MELDE "Gelndemodell nicht gefunden --> Die Ausfhrung des Skripts wird beendet!"
!DtmBezeichnung = Dtm.GetDescription()             | 
*
PointIndex.SetMarked(1)                            | Filter: nur markierte Punkte 
*
SOLANGE Point = PointIndex.GetNext()               | Schleife ber alle markierten Punkte 
  !PN = Point.GetName()
  X = Point.GetX()
  Y = Point.GetY()
  Z = Point.GetZ()
  DgmHoehe = Dtm.GetHeight(X;Y)
  WENN DgmHoehe==$UNDEF DANN
    FPkt = FPkt + 1
  SONST
    Differenz = Z - DgmHoehe
    * Hhendifferenz als Nebenattribut an Punktsymbol in Schicht schreiben
    !tdiff = !WERTFORM(Differenz;3;8;R)            | Differenzwert in Text wandeln
    Coordinate.SetX(Point.getx())
    Coordinate.SetY(Point.gety())
    PktSymbol = TopoSys.CreateSymbolAlpha(Schicht;!SK)   | Symbol erstellen 
    PktSymbol.SetSymbol(SymNr)                     | Symbolnummer 
    PktSymbol.SetPosition(Coordinate)              | Synbolposition 
    PktSymbol.SetAttribute("DeltaH-DGM_"+!DtmName;!tdiff)         | Symbol-Nebenattribut DGM-Name und DeltaH-Wert   

    NPkt = NPkt + 1
  WEITER
ENDE SOLANGE 
* Protokollausgabe
MELDE "Hhendifferenzen fr # markierte Punkte berechnet";NPkt
Wenn FPkt>0 Dann MELDE "Hhendifferenzen fr # markierte Punkte unbekannt"; FPkt

STOP
** ---------------------------------------------------------------------------------------------
FUNKTION Dialog1:
  * Klassen fr Dialog und deren Felder 
  SYMBOLE /DLG_WINDOW/ Dialog      | Dialogfenster
  SYMBOLE /DLG_FRAME/ Rahmen1;Rahmen2
  SYMBOLE /DLG_DTM/ Dgm1                   | DGM-Auswahl
  SYMBOLE /DLG_LAYER/ Schichtfeld
  SYMBOLE /DLG_SYMBOL/ SyNummer
  SYMBOLE /DLG_ACODELINE/ SyKode
  SYMBOLE * Ret
  EXTERN  * !DtmName;!DtmBezeichnung;Schicht;!Schicht;!Schichtbez;SymNr;!SK
  
  Dialog = NewObject /DLG_WINDOW/                    | Anlegen des Dialogfensters
  Dialog.SetCaption("markierte Punkte - DGM: DeltaH in Symbolnebenattribut ausgeben") | berschrift des Fensters 
  Rahmen1 = Dialog.CreateFrame(0)
  Rahmen2 = Dialog.CreateFrame(0)
  
  * Auswahl DGM + Bezeichnung
  Dgm1 = NewObject /DLG_DTM/                         | Neues Feld fr DGM Auswahl erstellen            
  Dgm1.SetLabel("DGM:")                              | Text fr Dialog angeben 
  Dgm1.SetName(!DtmName)                             | Feld fr DGM-Namen
  Dgm1.SetDescription(!DtmBezeichnung)               | Feld fr DGM-Bezeichnung
  Rahmen1.AddField(Dgm1)                             | Feld zum Dialog zufgen
  * Eingabe/Auswahl Schicht
  Schichtfeld  = NewObject /DLG_LAYER/
  Schichtfeld.SetLabel("Schicht:")
  Schichtfeld.SetSize(40)
  Schichtfeld.SetName(!Schicht)
  Schichtfeld.SetDescription(!Schichtbez)
  Schichtfeld.EnableNew()
  Rahmen1.AddField(Schichtfeld)
  * Eingabe/Auswahl Symbolkode
  SyKode = NewObject /DLG_ACODELINE/
  SyKode.SetDart(6)
  SyKode.SetLabel("Symbolkode:")
  Rahmen2.AddField(SyKode)
  * Eingabe/Auswahl Symbol
  SyNummer = NewObject /DLG_SYMBOL/
  SyNummer.SetLabel("Symbolnummer:")
  SyNummer.SetNumber(SymNr) 
  Rahmen2.AddField(SyNummer) 

  * Dialog ausfhren
  Ret = Dialog.DoDialog()          | Dialog ausfhren
  
  *  Auswertung des Dialoges nach Besttigung durch OK oder Abbruch
  WENN Ret DANN
    !DtmName = Dgm1.GetName()
    !DtmBezeichnung = Dgm1.GetName()
    !Schicht = Schichtfeld.GetName()
    !Schichtbez = Schichtfeld.GetDescription()
    SymNr = SyNummer.GetNumber()
    !SK = SyKode.GetCode()
  WEITER
  ZURCK Ret
ENDE FUNKTION

*******************************************************************************************************************


