VERSION 8000
* Dgm_Punkte_DeltaH_Zeichnung.CSX                        29.02.12
* -----------------------------------------------------------------------------
* @filedoc
* @file Dgm_Punkte_DeltaH_Zeichnung.CSX
* @brief Differenzen Punkthhen-DGM in Zeichnung 
* 
* < Mit dem Skript berechnen Sie die Hhendifferenzen zwischen markierten Punkten 
*   und einem DGM. 
*   Die Punkte werden als Symbolverweise, die Hhendifferenzen werden als Texte
*   in eine Zeichnung ausgegeben. >
*
* -----------------------------------------------------------------------------
* Copyright (C) IB&T
* 
* Gewhrleistung und Nutzung
* 
* Die Nutzung des Skriptes erfolgt stets auf eigene Gefahr. IB&T bernimmt keine
* Gewhr dafr, dass die Nutzung dieses Skriptes zu Ihrem gewnschten Ergebnis
* fhrt. Da CardScripte vorhandene Projektdaten durch Direktzugriff auf die
* jeweiligen Datenbanken auch ohne weitere Sicherheitsabfragen unbemerkt verndern
* oder lschen knnen, erfordert eine Nutzung entsprechende Kenntnisse und groe
* Sorgfalt. IB&T haftet nicht fr eventuell entstehende Datenverluste und
* Folgeschden, die durch die Nutzung von CardScripten entstehen.
*
* -----------------------------------------------------------------------------
* @author CK
* @endfiledoc
* -----------------------------------------------------------------------------
* @history
* -----------------------------------------------------------------------------
* 
BILDSCHIRM GRAFIK                | gibt die Meldungen im Arbeitsprotokoll aus
** Deklarationen -----------------------------------------------------------------------------------
SYMBOLE /DTMSYS/ DtmSys
SYMBOLE /DTM/ Dtm
SYMBOLE /PointSys/ PointSys
SYMBOLE /POINTINDEX/ PointIndex
SYMBOLE /Point/ Point
SYMBOLE /SHEETSYS/ BlattSys                        
SYMBOLE /SHEET/ Blatt
SYMBOLE /Coordinate/ Coordinate
SYMBOLE * Dialog_Status;!DtmName;!DtmBezeichnung;!PltName;!PltBez;!Blattname;BB;BH;!ZRand;!PltZObjName;!PltGruppe    
SYMBOLE * TextHoehe;TextFont;StiftNummer;SymbNr;SymbGr;!PN;NPkt;FPkt;X;Y;Z;DgmHoehe;Differenz;!tdiff 

* Systemobjekte
DtmSys = Project.GetDtmSys()
PointSys = Project.GetPointSys()                   | liefert das Objekt fr das System der Punkte
PointIndex = PointSys.GetPointIndex(1)             | liefert das Punktindexobjekt 

* Vorbelegungen
!DtmName = " "
!DtmBezeichnung = " " 
!PN = " "
NPkt = 0
FPkt = 0
!PltName = "Hoehendifferenzen.plt"
!PltBez  = "Hhendifferenzen DGM - Punkte"                 | Dateibezeichnung fr Zeichnung
!Blattname = " "
!ZRand = " " 
Stiftnummer = 2
SymbNr = 31
SymbGr = 0,5
TextFont = 100
TextHoehe = 0,25

* Ausfhrungen ------------------------------------------------------------------------------------
*
* Dialog zur Auswahl des DGM und Eingabe des Dateinamens 
Dialog_Status = Dialog1()                                  | Dialog ausfhren 
WENN Dialog_Status == 0 DANN STOP  MELDE "Abbruch des Dialoges"
* 
* Gelndemodell 
Dtm = DtmSys.GetDtm(!DtmName)                              | liefert das DGM-Objekt
WENN Dtm==$NULL DANN STOP MELDE "Gelndemodell nicht gefunden --> Die Ausfhrung des Skripts wird beendet!"
!DtmBezeichnung = Dtm.GetDescription()
*
* Blattschnitt definieren
BlattSys = Project.GetSheetSys()                           | liefert das Objekt fr das System der Blattschnitte
Blatt = Blattsys.GetSheet(!Blattname)                      | liefert das Blatt
BB = Blatt.GetExtentWidth()                                | Breite des Blattschnitts 
BH = Blatt.GetExtentHeight()                               | Hhe des Blattschnitts

!PltZObjName= !_TEIL(!PltName;1;T_LANG(!PltName)-4)        | Name fr Zeichnungsobjekt aus Plt-Namen ableiten
!PltGruppe = !PltZObjName +"_"+ !Blattname                 | Name fr Layergruppe festlegen

* Zeichnung ffnen und Layergruppe mit Layern anlegen und zeichnen
PLT_DAT_NEU !PltName ; !PltBez                             |neue Zeichnungsdatei anlegen
  PLT_LGR_LAGE !PltGruppe;"Layergruppe"+!PltBez;!Blattname | neue Layergruppe anlegen
    PLT_LAY_NEU "Differenzhoehen_"+!DtmName ;"Differenzhhen Punkte-DGM "+!DtmName| neuen Layer anlegen

    PointIndex.SetMarked(1)                                | Filter: nur markierte Punkte 
    
    SOLANGE Point = PointIndex.GetNext()                   | Schleife ber alle markierten Punkte 
      !PN = Point.GetName()
      X = Point.GetX()
      Y = Point.GetY()
      Z = Point.GetZ()
      DgmHoehe = Dtm.GetHeight(X;Y)                        | DGM-Hhe an markiertem Punkt
      WENN DgmHoehe == $UNDEF DANN
        FPkt = FPkt + 1
      SONST
        Differenz = Z - DgmHoehe
        !tdiff = !WERTFORM(Differenz;3;8;R)                | Differenz als Text  
        !tdiff = "dH="+!tdiff
        PLT_STIFT  Stiftnummer                             | Stiftnummer fr Zeichnung 
        PLT_SYM_VERW SymbNr;X;Y;SymbGr                     | Punktsymbol zeichnen 
        PLT_TEXT !tdiff;TextFont;RO;PF;X;Y;;;TextHoehe       | Text in Zeichnung ausgeben 
        NPkt = NPkt + 1
      WEITER
    ENDE SOLANGE 
  PLT_OBJ_ZU                                               | Layergruppe schlieen
  PLT_OBJ_NEU !PltZObjName ; !PltBez; "Z"                  | neues Zeichnungsobjekt anlegen
      PLT_ZRAND  !ZRand; BB; BH                            | Zeichnungsobjekt mit Zeichnungsrand versehen
      PLT_ZR_INFO "PLR_PINNR"; XInn; YInn                  | Einfgepunkt fr Objektverweis Layergruppe ermitteln
    PLT_OBJ_VERW !PltGruppe;XInn;YInn                      | Layergruppe in Zeichnungsobjekt einfgen
  PLT_OBJ_ZU                                               | Zeichnungsobjekt schlieen
PLT_DAT_ZU                                                 | Zeichnungsdatei schlieen 

MELDE "Hhendifferenzen fr # markierte Punkte berechnet und als Text in Zeichnung ausgegeben"; NPkt
Wenn FPkt>0 Dann MELDE "Hhendifferenzen fr # markierte Punkte unbekannt"; FPkt
STOP
* -------------------------------------------------------------------------------------------------
FUNKTION Dialog1:
  * Klassen fr Dialog und deren Felder 
  SYMBOLE /DLG_WINDOW/ Dialog      | Dialogfenster
  SYMBOLE /DLG_FRAME/ Rahmen1;Rahmen2
  SYMBOLE /DLG_DTM/ Dgm1                   | DGM-Auswahl
  SYMBOLE /DLG_FILENAME/ ZeichName
  SYMBOLE /DLG_SHEET/ Blatt
  SYMBOLE /DLG_SHEETBORDER/ ZRand
  SYMBOLE /MY_BUTTON/ DialogZ2
  SYMBOLE * Ret
  EXTERN  * !DtmName;!DtmBezeichnung;!PltName;!PltBez;!Blattname;!ZRand
  
  Dialog = NewObject /DLG_WINDOW/                    | Anlegen des Dialogfensters
  Dialog.SetCaption("markierte Punkte - DGM: DeltaH in Zeichnung ausgeben")      | berschrift des Fensters 
  Rahmen1 = Dialog.CreateFrame(0)
  Rahmen2 = Dialog.CreateFrame(0)
  
  * Auswahl DGM + Bezeichnung
  Dgm1 = NewObject /DLG_DTM/                               | Neues Feld fr DGM Auswahl erstellen            
  Dgm1.SetLabel("DGM:")                                    | Text fr Dialog angeben 
  Dgm1.SetName(!DtmName)                                   | Feld fr DGM-Namen
  Dgm1.SetDescription(!DtmBezeichnung)                     | Feld fr DGM-Bezeichnung
  Rahmen1.AddField(Dgm1)                                   | Feld zum Dialog zufgen
  * Eingabe/Auswahl PLT-Datei
  ZeichName = NewObject /DLG_FILENAME/                     | Dateiauswahlfeld fr Zeichnungsdatei 
  ZeichName.SetLabel("Zeichnung")
  ZeichName.SetSize(50)
  ZeichName.SetPattern("*.plt")
  ZeichName.SetName(!PltName)
  ZeichName.SetDescription(!PltBez)
  ZeichName.EnableNew()                                    | Eingabe neuer Dateinamen zulassen
  ZeichName.FixExtension()                                 | Eingabe neuer Dateinamen zulassen
  Rahmen1.AddField(ZeichName)
  * Blattschnitt whlen
  Blatt = NewObject /DLG_SHEET/                            | Eingabe fr Blattschnitt mit Listen- u. Grafikauswahlbutton   
  Blatt.SetLabel("Blattschnitt")
  Blatt.SetSize(50)
  Blatt.SetName(!Blattname)
  Rahmen1.AddField(Blatt)
  * Zeichnungsrand whlen
  ZRand = NewObject /DLG_SHEETBORDER/                      | Auswahlfeld Zeichnungsrand                      
  ZRand.SetLabel("Zeichnungsrand") 
  ZRand.SetSize(50)
  ZRand.SetName(!ZRand)
  Rahmen1.AddField(ZRand)
  * Button fr 2. Dialog mit eigener Klasse 
  DialogZ2 = NewObject /MY_BUTTON/
  DialogZ2.SetId(9001)                                                      
  DialogZ2.SetCaption("Gestaltung")
  Dialog.AddButton(DialogZ2)
  
  * Dialog ausfhren
  Ret = Dialog.DoDialog()          | Dialog ausfhren
  
  *  Auswertung des Dialoges nach Besttigung durch OK oder Abbruch
  WENN Ret DANN
    !DtmName = Dgm1.GetName()
    !PltName = ZeichName.GetName()
    !PltBez = ZeichName.GetDescription()
    !Blattname= Blatt.GetName()
    !ZRand = ZRand.GetName()
  WEITER
  ZURCK Ret
ENDE FUNKTION

* -------------------------------------------------------------------------------------------------
KLASSE /MY_BUTTON/; /DLG_BUTTON/
  * -----------------------------------------------------------------------------
  * @function Push
  * @brief <wird vom Dialogsystem aufgerufen wenn der Button gedrckt wird>
  *
  * @ingroup
  * @author CK
  * @endfunction
  FUNKTION {long} Push:
    VERZWEIGE GetId()
    ZWEIG 9001
      Gestaltung_Dialog()   | Funktion fr 2. Dialog ausfhren
    Ende VERZWEIGE 
  ENDE FUNKTION 
  * -----------------------------------------------------------------------------
  * @function Gestaltung_Dialog
  * @brief <Dialog mit Feldern fr Gestaltung (Farb-, Stift-, Strichauswahl etc.) >
  *
  * @ingroup
  * @author CK
  * @endfunction
  FUNKTION Gestaltung_Dialog:
    SYMBOLE /DLG_WINDOW/ Dialog
    SYMBOLE /DLG_PEN/ Stift
    SYMBOLE /DLG_SYMBOL/ Symbol
    SYMBOLE /DLG_FONT/ Font
    SYMBOLE /DLG_NUMBER/ THoehe;SymHoehe
    EXTERN * Ret;Stiftnummer;SymbNr;SymbGr;TextFont;TextHoehe 

*..................Dialog anlegen
    Dialog =  NEWOBJECT /DLG_WINDOW/
    Dialog.SetCaption("Zeichnungsgestaltung")

*..................Feld fr Symbolnummer mit Auswahl
    Symbol = NewObject /DLG_SYMBOL/
    Symbol.SetNumber(SymbNr)
    Symbol.SetLabel("Punktsymbol:")
    Dialog.AddField(Symbol)
*..................Feld fr Symbolgre
    SymHoehe = NewObject /DLG_NUMBER/
    SymHoehe.SetValue(SymbGr)
    SymHoehe.SetSize(11;2)
    SymHoehe.SetLabel("Symbolgre:")
    Dialog.AddField(SymHoehe)
*..................Feld fr Stift mit Auswahl
    Stift = NewObject /DLG_PEN/
    Stift.SetNumber(Stiftnummer)
    Stift.EnableColorNeutral()
    Stift.SetLabel("Stift:")
    Dialog.AddField(Stift)
*..................Feld fr Textfont mit Auswahl
    Font = NewObject /DLG_FONT/
    Font.SetNumber(Textfont)
    Font.SetLabel("TextFont:")
    Dialog.AddField(Font)
*..................Feld fr Texthhe 
    THoehe = NewObject /DLG_NUMBER/
    THoehe.SetValue(TextHoehe)
    THoehe.SetSize(11;2)
    THoehe.SetLabel("Texthhe:")
    Dialog.AddField(THoehe)
    
*..................Dialog ausfhren
    Ret = Dialog.DoDialog()

*..................Ergebnis
    WENN Ret DANN
      Stiftnummer = Stift.GetNumber()
      SymbNr = Symbol.GetNumber()
      SymbGr = SymHoehe.GetValue()
      TextFont = Font.GetNumber()
      TextHoehe = THoehe.GetValue()
    WEITER
  ENDE FUNKTION
  * -----------------------------------------------------------------------------
ENDE KLASSE  
  * -----------------------------------------------------------------------------




























