VERSION 8; ; 8300

* -----------------------------------------------------------------------------
* @filedoc
* @file PuWo_Punkthoehen.CSX
* @brief Bsp. fr Hhenermittlung aus Punktwolke 
* 
* Beispiel: Hhen fr markierte Punkte aus Punktwolke ermitteln
*
* -----------------------------------------------------------------------------
* Copyright (C) IB&T
* 
* Gewhrleistung und Nutzung
* 
* Die Nutzung des Skriptes erfolgt stets auf eigene Gefahr. IB&T bernimmt keine
* Gewhr dafr, dass die Nutzung dieses Skriptes zu Ihrem gewnschten Ergebnis
* fhrt. Da CardScripte vorhandene Projektdaten durch Direktzugriff auf die
* jeweiligen Datenbanken auch ohne weitere Sicherheitsabfragen unbemerkt verndern
* oder lschen knnen, erfordert eine Nutzung entsprechende Kenntnisse und groe
* Sorgfalt. IB&T haftet nicht fr eventuell entstehende Datenverluste und
* Folgeschden, die durch die Nutzung von CardScripten entstehen.
*
* -----------------------------------------------------------------------------
* @author BB
* @endfiledoc
* -----------------------------------------------------------------------------
* @history
* -----------------------------------------------------------------------------

* Vereinbarungen -------------------------------------------------------------------------------------

BILDSCHIRM GRAFIK                                   | gibt die Meldungen im Arbeitsprotokoll aus

* Zuweisungen ----------------------------------------------------------------------------------------

DS = 0,2                                            | Suchdurchmesser fr die Punktwolke
NPkt = 0                                            | Anzahl Punkte 

* Deklarationen --------------------------------------------------------------------------------------

SYMBOLE /POINTSYS/ PointSys                         | Symbol fr das System der Punkte
SYMBOLE /POINT/ Point                               | Symbol fr den Punkt

SYMBOLE /POINTCLOUDSYS/ CloudSys                    | Symbol fr das System der Punktwolken
SYMBOLE /POINTCLOUD/ PointCloud                     | Symbol fr die Punktwolke
SYMBOLE /POINTCLOUDSECTION/ Section                 | Symbol fr das Ausschnittobjekt

SYMBOLE /COORDINATE/ Coord                          | Symbol fr den Hilfspunkt

* Ausfhrungen ---------------------------------------------------------------------------------------

MELDE "Hhen fr markierte Punkte aus Punktwolke"   
MELDE "Hhenermittlung wird gestartet ..."

* Systemobjekte
PointSys= Project.GetPointSys()                     | liefert das Objekt fr das System der Punkte
CloudSys = Project.GetPointCloudSys()               | liefert das Objekt fr das System der Punktwolken

* Punktwolkenobjekt
PointCloud = CloudSys.GetPointCloud(0)              | liefert die aktuelle Punktwolke
WENN PointCloud == $NULL DANN STOP MELDE "Punktwolke ist nicht vorhanden --> Hhenermittlung wird abgebrochen!"

* Punktobjekt
SOLANGE Point = PointSys.GetNextMarkedPoint(Point)  | liest markierte Punkte fortlaufend aus

  Rechts = Point.GetX()                             | liefert den Rechtswert des markierten Punktes 
  Hoch = Point.GetY()                               | liefert den Hochwert des markierten Punktes  
  * Hilfspunktobjekt
  Coord = Point.GetCoordinate()                     | liefert die Koordinate des markierten Punktes als Hilfspunkt
  * Ausschnittobjekt
  Section = PointCloud.CreateSection()              | erzeugt einen Ausschnitt aus der Punktwolke
  Section.SetCircleSection(Rechts; Hoch; DS)        | definiert den Punktwolkenausschnitt als Suchzylinder 
  Anz = Section.GetCount()                          | liefert die Anzahl der Scannerpunkte im Zylinder
  WENN Anz > 0 DANN 
     Z = Section.GetMinZ()                          | liefert die Hhe des tiefsten Scannerpunktes 
     Point.SetHeight(Z)                             | speichert die Hhe fr Punkt in der Punktdatenbank 
     Coord.Draw(1; 6)                               | markiert den Punkt blau
     NPkt = NPkt + 1
   SONST                                            | Wenn keine Hhe fr den Punkt ermittelt wurde,
     Coord.Draw(2; 6)                               | wird der Punkt rot markiert
   WEITER
   Section = $NULL                                  | gibt das Objekt wieder frei

ENDE SOLANGE

MELDE "# Hhen fr markierte Punkte ermittelt"; NPkt 
MELDUNG NEUTRAL "Hhenermittlung fr markierte Punkte abgeschlossen"