VERSION 10000;;10105
* TOPO_Linienpunkte_auf_mark_Punkte.CSX  Linienpunkte auf markierte Punkte setzen  05.03.25
* -----------------------------------------------------------------------------
* @filedoc
* @file TOPO_Linienpunkte_auf_mark_Punkte.CSX
* @brief Linienpunkte auf markierte Punkte setzen 
* 
* Mit diesem Skript lassen sich fr alle oder markierte Linien einer Schicht Lininepunkte
* auf markierte Punkte setzen.
* Ist an der Koordinate eines Linienpunktes incl. einer im Dialog eingegebenen Suchtoleranz
* ein markierter Punkt vorhanden, wird dieser an Stelle des koordinatengesttzten 
* Linienpunktes in die Linie eingefgt. Die Hhe wird dabei nicht bercksichtigt.
* Eine ggf. vorhandene Hhe des Linienpunktes wird durch die Punkthhe berschieben
* 
*
* -----------------------------------------------------------------------------
* Copyright (C) IB&T
* 
* Gewhrleistung und Nutzung
* 
* Die Nutzung des Skriptes erfolgt stets auf eigene Gefahr. IB&T bernimmt keine
* Gewhr dafr, dass die Nutzung dieses Skriptes zu Ihrem gewnschten Ergebnis
* fhrt. Da CardScripte vorhandene Projektdaten durch Direktzugriff auf die
* jeweiligen Datenbanken auch ohne weitere Sicherheitsabfragen unbemerkt verndern
* oder lschen knnen, erfordert eine Nutzung entsprechende Kenntnisse und groe
* Sorgfalt. IB&T haftet nicht fr eventuell entstehende Datenverluste und
* Folgeschden, die durch die Nutzung von CardScripten entstehen.
*
* -----------------------------------------------------------------------------
* @author Ch
* @endfiledoc
* -----------------------------------------------------------------------------
* @history
* -----------------------------------------------------------------------------
* 
BILDSCHIRM GRAFIK
$CHECKLEVEL 7
*

SYMBOLS /TOPOSYS/         TopoSys    | Methoden fr Zugriff auf Schichten und Topografiedaten
SYMBOLS /TOPOLAYER/       Schicht    | Methoden zum Bearbeiten und Auswerten von SchichtAttributen
SYMBOLS /TOPOLINE/        Linie      | Methoden zum Bearbeiten und Auswerten von Linie
SYMBOLS /TOPOLINEELEMENT/ LinElement | Methoden zum Bearbeiten und Auswerten von LinienElementen
SYMBOLS /TOPOLINEINDEX/   XLinie     | Methoden zum Bearbeiten und Auswerten von LinienIndex
SYMBOLS /POINTSYS/        PunktSys
SYMBOLS /POINT/           Punkt
SYMBOLS /COORDINATE/      LPKoor
SYMBOLS /OBJECTLIST/      PktListe 
SYMBOLS * Ret;!Schichtname;MarkLin;EleAnzahl;I;PktID;!PktName;Suchtoleranz;LinAnz;PktAnz

Toposys = Project.GetTopoSys() 
PunktSys = Project.GetPointSys() 
PktListe = NewObject /OBJECTLIST/
LinAnz = 0          | Vorbelegung Anzahl Linien
PktAnz = 0          | Vorbelegung Anzahl Punkte
!Schichtname = " "  | Vorbelegung leer, Schicht wird im Dialog ausgewhlt
MarkLin = 0         | Vorbelegung "alle Linien", Schalter wird im Dialog gesetzt
Suchtoleranz = 0,01 | Vorbelegung 1 cm, Wert wird aus Dialog bernommen

* Dialog
Ret = LinPkt_Dialog([!Schichtname];[Suchtoleranz];[MarkLin]) | Schicht, Suchtoleranz und Einschrnkung auf markierte Linien im Dialog ermitteln

* Linienindex der ausgewhlten Schicht
XLinie = TopoSys.GetLineIndex(!Schichtname)
LinAnz = 0          | Vorbelegung Anzahl Linien
PktAnz = 0          | Vorbelegung Anzahl Punkte

* Protokollausgabe
Report "Untersuchung fr:"
IF MarkLin = 1 THEN
  Report "Markierte Linien der Schicht '#'";!Schichtname 
ELSE
  Report "Alle Linien der Schicht '#'";!Schichtname  
END IF

* Schleife ber alle Linien der Schicht
WHILE Linie = XLinie.GetNext()              
  IF MarkLin = 1 THEN                       | Schalter fr "nur nur markierte Linien" gesetzt
    IF Linie.IsMarked() = 0 THEN NEXT WHILE | ist die Linie nicht markiert, berspringen  
  END IF
  LinAnz = LinAnz+1
  EleAnzahl = Linie.GetElementCount()       | Element-Anzahl ermitteln
  LOOP I = 1;EleAnzahl                      | Schleife ber alle Elemente
    LinElement = Linie.GetElement(I)        | Linienelement
    LPKoor = LinElement.GetCoordinate()     | Linienelementpunkt
    Punkt = PunktSys.FindPoint(LPKoor.GetX();LPKoor.GetY();Suchtoleranz;$UNDEF;$UNDEF;1) |markierten Punkt suchen, ohne Kode-Einschrnkung
    IF Punkt <> $NULL THEN                  | Punkt ist vorhanden
      PktID = Punkt.GetId()                 | Punkt-ID ermitteln
      !PktName = Punkt.GetName()            | Punktnummer ermitteln
      LinElement.SetPointId(PktID)          | Punkt auf Linienelement zuweisen
      IF PktListe.GetObjectByName(!PktName) = $NULL THEN | Prfen, ob Punkt in Liste vorhanden ist
        PktListe.AddNamedObject(Punkt;!PktName) | Punkt in Liste einfgen
      END IF  
    END IF  
  END LOOP
END WHILE

* Protokollausgabe Ergebnis
PkTAnz = PktListe.GetCount() | Anzahl der eingefgten Puntke ermitteln 
Report "# Linien untersucht";LinAnz
Report "# markierte Punkte in Linien eingefgt";PktAnz

STOP

* -----------------------------------------------------------------------------
* @function LinPkt_Dialog
* @brief <Dialog fr Schichtwahl, Suchtoleranz und Angabe fr markierte oder alle Linien >
* @param !Schicht: ausgewhlte Schicht
* @param PktAbstand: Suchtoleranz fr Punktfindung
* @param LMark: Checkwert fr Einschrnkung auf markierte Linien
*
* @ingroup
* @author Ch
* @endfunction
FUNCTION LinPkt_Dialog: !Schicht; PktAbstand; LMark
  SYMBOLS /DLG_WINDOW/      Dialog
  SYMBOLS /DLG_LAYER/       DF_Schicht
  SYMBOLS /DLG_NUMBER/      DF_Abstand
  SYMBOLS /DLG_CHECKBOX/    DF_LinMark
  SYMBOLS * Ret
  
  INSYMBOLS 0
  INSYMBOLS "Linpkt.Ini"
  
  Dialog = NEWOBJECT /DLG_WINDOW/
  Dialog.SetCaption("Linienpunkte auf markiere Punkte setzen")    | berschrift des Fensters 
  * Schichtauswahl
  DF_Schicht = Newobject
  DF_Schicht.SetLabel("Linien aus Schicht:")
  DF_Schicht.SetName(!Schicht)
  DF_Schicht.DisableDescription()
  Dialog.AddField(DF_Schicht) 
  * Checkbox "marierte Linien"
  DF_LinMark = Newobject
  DF_LinMark.SetBoxLabel("Nur markierte Linien")
  DF_LinMark.SetValue(LMark)
  Dialog.AddField(DF_LinMark) 
  * Werteingabe Suchtoleranz
  DF_Abstand = Newobject
  DF_Abstand.SetLabel("Suchtoleranz mark. Punkte:")
  DF_Abstand.SetSize(16;4)
  DF_Abstand.SetValue(PktAbstand)
  Dialog.AddField(DF_Abstand) 

 *....................Dialog ausfhren
  Ret = Dialog.DoDialog()

  IF Ret == 1 THEN
    !Schicht = DF_Schicht.GetName()
    PktAbstand = DF_Abstand.GetValue()
    LMark = DF_LinMark.GetValue()
  
    OUTSYMBOLS !Schicht;PktAbstand;LMark
  END IF
  
  Return Ret
END FUNCTION

