VERSION 8000; ; 8300

* -----------------------------------------------------------------------------
* @filedoc
* @file Plot_AxHpktObjekteMitTextvariablen.CSX
* @brief Zeichnung mit Textvariablen an Objektverweisen erstellen 
* 
* Dieses Beispielskript erzeugt eine Zeichnung mit Objektverweisen auf den Hauptpunkten der Achse 1.
* Das Objektverweis enthlt Informationen zum Achshauptpunkt (wie Koordinate, Station und Winkel), 
* die in Form von Textvariablen am Objektverweis abgelegt sind.
*
* -----------------------------------------------------------------------------
* Copyright (C) IB&T
* 
* Gewhrleistung und Nutzung
* 
* Die Nutzung des Skriptes erfolgt stets auf eigene Gefahr. IB&T bernimmt keine
* Gewhr dafr, dass die Nutzung dieses Skriptes zu Ihrem gewnschten Ergebnis
* fhrt. Da CardScripte vorhandene Projektdaten durch Direktzugriff auf die
* jeweiligen Datenbanken auch ohne weitere Sicherheitsabfragen unbemerkt verndern
* oder lschen knnen, erfordert eine Nutzung entsprechende Kenntnisse und groe
* Sorgfalt. IB&T haftet nicht fr eventuell entstehende Datenverluste und
* Folgeschden, die durch die Nutzung von CardScripten entstehen.
*
* -----------------------------------------------------------------------------
* @author JH
* @endfiledoc
* -----------------------------------------------------------------------------
* @history
* -----------------------------------------------------------------------------


* --- Vereinbarungen ----------------------------------------------------------

BILDSCHIRM GRAFIK                                | gibt Meldungen im Arbeitsprotokoll aus


* --- Implizite Deklarationen -------------------------------------------------

!Plt_Name = "Lage_AxHpktZeichnung.PLT"
!Plt_Bez = "Lagezeichnung mit globalem Blattschnitt"
!Plt_Lgr = "Lage_AxHpktZeichnung_$Lage"
!Plt_Lay1 = "AX_Hpkt"

ANum = 1


* --- Explizite Deklarationen -------------------------------------------------

SYMBOLE /ALIGNMENTSYS/ AxeSys                    | Symbol fr das System der Achsen
SYMBOLE /ALIGNMENT/ Axe                          | Symbol fr die Achse
SYMBOLE /ALIGNMENTELEMENT/ AxeEle                | Symbol fr das Achselement


* --- Ausfhrungen ------------------------------------------------------------

PLT_DAT_NEU !Plt_Name; !Plt_Bez                                 | erzeugt neue PLT-Zeichnungsdatei
PLT_LGR_LAGE !Plt_Lgr; "Globaler Blattschnitt"; "$LAGE"         | erzeugt neue Layergruppe mit globalem Blattschnitt (Projektkoordinaten)
PLT_LAY_NEU !Plt_Lay1; "Achsinformationen"                      | erzeugt neuen Layer fr die aktuelle Layergruppe

* Systemobjekt
AxeSys = Project.GetAlignmentSys()
* Achsobjekt
Axe = AxeSys.GetAlignment(ANum)                                 | liefert die Achse  
  WENN Axe == $NULL DANN STOP MELDE "Achse # nicht vorhanden!"; ANum
    
*** Schleife ber alle Achselemente 

SCHLEIFE API = 1; 1000

  * Achselementobjekt
  AxeEle = Axe.GetElement(API)                                  | liefert das Achselement
    WENN AxeEle == $NULL DANN ABBRUCH SCHLEIFE
    
  Station = AxeEle.GetChainage()                                | liefert die Station am Elementanfang      
    TEXTGEN !Text; "#.###"; Station                             | generiert einen Text     
    PLT_VERW_ATTR "STAT"; !Text                                 | definiert eine Verweisvariable
    
  X = AxeEle.GetX1()                                            | liefert den Rechtswert am Elementanfang  
    TEXTGEN !Text; "#.###"; X
    PLT_VERW_ATTR "X"; !Text
    
  Y = AxeEle.GetY1()                                            | liefert den Hochwert am Elementanfang
    TEXTGEN !Text; "#.###"; Y
    PLT_VERW_ATTR "Y"; !Text
    
  Winkel = AxeEle.GetDirection1()                               | liefert die Richtung [rad] am Elementanfang
    Winkel = WNK_AUSA(Winkel)                                   | Umrechnung: Winkel im Bogenma -> Winkel in eingestellter Einheit
    TEXTGEN !Text; "#.#####"; Winkel
    PLT_VERW_ATTR "WINK"; !Text

  PLT_OBJ_VERW "AX_PKT(TEXTVAR_OBJ.PLT)"; X; Y; 1; 1; Winkel    | platziert Objektverweis mit Beschriftungen am Elementanfang

ENDE SCHLEIFE  

*** Ende Schleife 

PLT_DAT_ZU                                                      | schliet PLT-Datei

TEXTGEN !MeldeEnde; "Zeichnung '#' wurde erzeugt!"; !Plt_Name
MELDUNG NEUTRAL; !MeldeEnde