VERSION 8000; ; 8420
* -----------------------------------------------------------------------------
* @filedoc
* @file Plot_Punkte.CSX
* @brief Lageplanzeichnung fr Punkte erstellen
* 
* Mit diesem Beispielskript erstellen Sie eine Lageplanzeichnung fr alle 
* oder nur fr markierte Punkte.
* Smtliche Parameter lassen sich im Dialog eingeben. 
* Als Beschriftung sind Punktnummer und Punkthhe vorgesehen.
*
* -----------------------------------------------------------------------------
* Copyright (C) IB&T
* 
* Gewhrleistung und Nutzung
* 
* Die Nutzung des Skriptes erfolgt stets auf eigene Gefahr. IB&T bernimmt keine
* Gewhr dafr, dass die Nutzung dieses Skriptes zu Ihrem gewnschten Ergebnis
* fhrt. Da CardScripte vorhandene Projektdaten durch Direktzugriff auf die
* jeweiligen Datenbanken auch ohne weitere Sicherheitsabfragen unbemerkt verndern
* oder lschen knnen, erfordert eine Nutzung entsprechende Kenntnisse und groe
* Sorgfalt. IB&T haftet nicht fr eventuell entstehende Datenverluste und
* Folgeschden, die durch die Nutzung von CardScripten entstehen.
*
* -----------------------------------------------------------------------------
* @author BS
* @endfiledoc
* -----------------------------------------------------------------------------
*    8411 08.08.12 BH Umstellung auf neue Dialoge
*    8420 21.02.14 Bezeichnungsfeld fr DLG_PEN im Dialog entfernt
* @history
* 
* -----------------------------------------------------------------------------

* Vereinbarungen --------------------------------------------------------------
$PRFSTUFE 7
BILDSCHIRM GRAFIK                | gibt die Meldungen im Arbeitsprotokoll aus

* Deklarationen ---------------------------------------------------------------

SYMBOLE /POINTSYS/ PointSys                                                   | Symbol fr System der Punkte
SYMBOLE /POINT/ Punkt                                                         | Symbol fr den Punkt
SYMBOLE /POINTINDEX/ XPunkt                                                   | Symbol fr Punktindex

SYMBOLE * !PltName;!PltVorname;TXT_L;!PltBez;!PltLgr;!PltObj;!ObjBez;!Blatt   | Textsymbole fr den Dialog 
SYMBOLE * PuAusw;PNPl;PHPl;SymNr;Stift1;Stift2;Stift3;Schrift1;Schrift2       | Wertsymbole fr den Dialog
SYMBOLE * !PuNum;!PuHoe;Rechts;Hoch;SchriftH                                  | Symbole fr Zeichnungserstellung

SYMBOLE * RET

* Voreinstellungen
!PltName = " "                                                                | Name der PLT-Datei
!PltVorname = " "                                                             | Name der PLT-Datei ohne Endung .PLT
!PltBez  = "Lageplanzeichnung fr Punkte"                                     | Bezeichnung der PLT-Datei
!PltObj = "Punkte"                                                            | Name des Layers
!ObjBez = "Punkt Informationen"                                               | Bezeichnung fr Layerobjekt
!Blatt   = "$LAGE"                                                            | Name des Blattschnittes
PuAusw = 1                                                                    | alle (1) oder markierte (2) Punkte zeichnen
SymNr  = 11                                                                   | Symbolnummer zur Kennzeichnung der Punkte
Stift1   = 1                                                                  | Stift fr Punktsymbol
Stift2   = 1                                                                  | Stift fr Punktnummer
Stift3   = 1                                                                  | Stift fr Punkthhe
PNPl   = 1                                                                    | ohne (0) oder mit (1) Punktnummer beschriften
PHPl   = 1                                                                    | ohne (0) oder mit (1) Punkthhe beschriften
Schrift1  = 100                                                               | Schriftart fr Punktnummern
Schrift2  = 100                                                               | Schriftart fr Punkthhen
SchriftH  = 0,25                                                              | Schrifthhe

* Ausfhrungen ----------------------------------------------------------------
Ret = DIALOG_PUPLOT()                                                         | Funktionsaufruf Dialog                       

WENN RET == 0 DANN STOP
*....................Protokollausgabe
  WENN PuAusw = 1 DANN  
    Melde "Punktauswahl    alle Punkte"
  SONST
    Melde "Punktauswahl    markierte Punkte"
  WEITER
  WENN PNPl = 1 DANN 
    MELDE "Punktnummern zeichnen    ja"
  SONST
    MELDE "Punktnummern zeichnen    nein"
  WEITER
  WENN PHPl = 1 DANN
    MELDE "Punkthhen zeichnen    ja"
  SONST
    MELDE "Punkthhen zeichnen    nein"
  WEITER
    MELDE "SymbolNr  #";SymNr


* Zeichnungsdatei ffnen
PLT_DAT_NEU !PltName; !PltBez                                                  | legt eine neue Zeichnungsdatei an
TEXTGEN !PltLgr; "#_#"; !PltVorName; !Blatt 
PLT_LGR_LAGE !PltLgr; "Globaler Blattschnitt"; !Blatt                          | legt fr die aktuelle Zeichnungsdatei eine Layergruppe an
PLT_LAY_NEU !PltObj; !ObjBez                                                   | legt fr die aktuelle Layergruppe ein Layerobjekt an 

* Systemobjekt
PointSys = Project.GetPointSys()

* Punktindexobjekt
XPunkt = PointSys.GetPointIndex()
WENN PuAusw == 2 DANN XPunkt.SetMarkFilter(1)                                  | setzt Filter ber markierte Punkte (bei Option 2)

* Schleife ber alle Punkte: Punkte mit Symbol und Beschriftung zeichnen 
SOLANGE Punkt=XPunkt.GetNext()
  WENN Punkt == $NULL DANN ABBRUCH SOLANGE

  * Punktkoordinate ermitteln und Punksymbol zeichnen
  Rechts = Punkt.GetX()
  Hoch = Punkt.GetY()
  PLT_STIFT Stift1
  PLT_SYM_VERW SymNr; Rechts; Hoch; 1; 1; 0
  * Punktnummer ermiteln und zeichnen
  WENN PNPl == 1 DANN
    !PuNum = Punkt.GetName()
    PLT_STIFT Stift2
    PLT_TEXT !PuNum; Schrift1; ROA; PHF; Rechts; Hoch;;;SCHRIFTH
  WEITER
  * Punkthhe ermitteln und zeichnen
  WENN PHPL == 1 DANN
    TEXTGEN !PuHoe; "#.###"; Punkt.GetZ()
    PLT_STIFT Stift3
    PLT_TEXT !PuHoe; Schrift2; RUA; PHF; Rechts; Hoch;;;SCHRIFTH
  WEITER

ENDE SOLANGE

* Zeichnungsdatei schlieen
PLT_DAT_ZU

MELDUNG NEUTRAL "Lageplanzeichnung fr Punkte erstellt"

* -----------------------------------------------------------------------------
* @function DIALOG_PUPLOT
* @brief <Dialog fr Lageplanzeichnung fr Punkte (alle oder markierte) erstellen.>
*
* @ingroup
* @author BH
* @endfunction
FUNKTION DIALOG_PUPLOT:
* Deklarationen fr den Dialog
  SYMBOLE /DLG_WINDOW/ Dialog                                                  | Dialog 
  SYMBOLE /DLG_COMBOBOX/ DLGCombo                                              | Dialogfeld fr Combobox 
  SYMBOLE /DLG_CHECKBOX/ DLGCheck1; DLGCheck2                                  | Dialogfelder fr 2 Checkboxen 
  SYMBOLE /DLG_SYMBOL/ DLGSymbol                                               | Dialogfeld fr Symbol  
  SYMBOLE /DLG_FRAME/ DLGFrame1; DLGFrame2;DLGFrame3 ;DLGFrame4                | Dialogfelder fr 4 Rahmen 
  SYMBOLE /DLG_SHEET/ DLGBlatt                                                 | Dialogfeld fr Blattschnitt 
  SYMBOLE /DLG_PEN/ DLGStift1;DLGStift2;DLGStift3                              | Dialogfelder fr 3 Stifte
  SYMBOLE /DLG_FILENAME/ DLGPltDat                                             | Dialogfeld fr Dateinamen
  SYMBOLE /DLG_TEXT/ DLGPltObj; DLGPltBez; DLGObjBez                           | Dialogfelder fr Texte
  SYMBOLE /DLG_FONT/ DLGSchrift1;DLGSchrift2                                   | Dialogfelder fr Schiftauswahl

  SYMBOLE * RET;FeldLaenge
*
  EXTERN * !PltName;!PltVorname;TXT_L;!PltBez;!PltLgr;!PltObj;!ObjBez;!Blatt   | Textsymbole fr den Dialog 
  EXTERN * PuAusw;PNPl;PHPl;SymNr;Stift1;Stift2;Stift3;Schrift1;Schrift2       | Wertsymbole fr den Dialog
  
*..................Dialog anlegen
  Dialog = NewObject /DLG_WINDOW/
  Dialog.SetHelp("Allgemein")
  Dialog.SetCaption("Lageplanzeichnung fr Punkte erstellen")
* .................. Dialog Rahmen anlegen
  DLGFrame1 = Dialog.CreateFrame(0;"Punktauswahl")
  DLGFrame2 = Dialog.CreateFrame(1;"Blattwahl")
  DLGFrame3 = Dialog.CreateFrame(0;"Darstellung")
  DLGFrame4 = Dialog.CreateFrame(0;"Ergebnis")
  FeldLaenge = 166
  DLGFrame3.SetSize(FeldLaenge)
  DLGFrame4.SetSize(FeldLaenge)

*...................Felder anlegen  

*...................Feld fr Combobox anlegen und fllen
  DLGCombo = NewObject /DLG_COMBOBOX/
  DLGCombo.SetLabel("Punktauswahl           ") 
  DLGCombo.AddText("alle Punkte"; 1) 
  DLGCombo.AddText("markierte Punkte"; 2) 
  DLGCombo.SetValue(PuAusw)
  DLGFrame1.AddField(DLGCombo)

*..................Feld fr Blattwahl mit Auswahl
  DLGBlatt = NewObject /DLG_SHEET/
  DLGBlatt.SetLabel("Blattname:")
  DLGBlatt.SetName(!Blatt)
  DLGFrame2.AddField(DLGBlatt)

*..................Feld fr Symbolnummer mit Auswahl
  DLGSymbol = NewObject /DLG_SYMBOL/
  DLGSymbol.SetNumber(SymNr)
  DLGSymbol.SetLabel("Symbol:")
  DLGFrame3.AddField(DLGSymbol)

* .................Feld fr Stiftauswahl
  DLGStift1 = NewObject /DLG_PEN/
  DLGStift1.AppendRight()
  DLGStift1.DisableDescription()
  DLGStift1.SetNumber(Stift1)
  DLGStift1.SetLabel("Stift:")
  DLGFrame3.Addfield(DLGStift1)

*...................Feld fr Checkbox
  DLGCheck1 = NewObject /DLG_CHECKBOX/
  DLGCheck1.SetBoxLabel("Punktnummer beschriften")
  DLGCheck1.SetFieldLabel(" ")
  DLGCheck1.SetValue(PNPl)
  DLGFrame3.AddField(DLGCheck1)

* .................Feld fr Stiftauswahl
  DLGStift2 = NewObject /DLG_PEN/
  DLGStift2.AppendRight()
  DLGStift2.DisableDescription()
  DLGStift2.SetNumber(Stift2)
  DLGStift2.SetLabel("Stift:")
  DLGStift2.AddObserveField(DLGCheck1;1;1;1)
  DLGFrame3.Addfield(DLGStift2)

* .................Feld fr Schriftauswahl
  DLGSchrift1 = NewObject /DLG_FONT/
  DLGSchrift1.AppendRight()
  DLGSchrift1.SetNumber(Schrift1)
  DLGSchrift1.SetLabel("Schriftart:")
  DLGSchrift1.AddObserveField(DLGCheck1;1;1;1)
  DLGFrame3.AddField(DLGSchrift1)

* .................Feld fr 2. Checkbox
  DLGCheck2 = NewObject /DLG_CHECKBOX/
  DLGCheck2.SetBoxLabel("Punkthhe beschriften")
  DLGCheck2.SetFieldLabel(" ")
  DLGCheck2.SetValue(PHPl)
  DLGFrame3.AddField(DLGCheck2)

* .................Feld fr Stiftauswahl
  DLGStift3 = NewObject /DLG_PEN/
  DLGStift3.AppendRight()
  DLGStift3.DisableDescription()
  DLGStift3.SetNumber(Stift3)
  DLGStift3.SetLabel("Stift:")
  DLGStift3.AddObserveField(DLGCheck2;1;1;1)
  DLGFrame3.Addfield(DLGStift3)

* .................Feld fr Schriftauswahl
  DLGSchrift2 = NewObject /DLG_Font/
  DLGSchrift2.AppendRight()
  DLGSchrift2.SetNumber(Schrift2)
  DLGSchrift2.SetLabel("Schriftart:")
  DLGSchrift2.AddObserveField(DLGCheck2;1;1;1)
  DLGFrame3.AddField(DLGSchrift2)

*..................Feld fr Dateiwahl mit Auswahl
  DLGPltDat = NewObject /DLG_FILENAME/
  DLGPltDat.EnableNew()
  DLGPltDat.SetPattern("*.PLT")
  DLGPltDat.SetDescription(!PltBez)
  DLGPLTDat.FixExtension()
  DLGPltDat.SetLabel("Name PLT-Datei:")
  DLGFrame4.AddField(DLGPltDat)

*..................Feld fr Layername
  DLGPltObj = NewObject /DLG_TEXT/
  DLGPltObj.SetSize(40)
  DLGPltObj.SetLabel("Name Layer:")
  DLGPltObj.SetText(!PltObj)
  DLGFrame4.AddField(DLGPltObj)

*....................Dialog ausfhren
  Ret = Dialog.DoDialog(1)

*....................Ergebnis
  WENN Ret DANN
    Wenn Dialog.IsChanged() Dann Melde "Werte gendert!"
    PNPl = DLGCheck1.GetValue()
    PHPl = DLGCheck2.GetValue()
    PuAusw = DLGCombo.GetValue()
    SymNr = DLGSymbol.GetNumber()
    Stift1 = DLGStift1.GetNumber()
    Stift2 = DLGStift2.GetNumber()
    Stift3 = DLGStift3.GetNumber()
    !PltName = DLGPltDat.GetName()
    TXT_L=T_LANG(!PltName)
    !PltVorname=!_TEIL(!PltName;1;TXT_L-4)
    !PltBez  = DLGPltDat.GetDescription()                      | Bezeichnung der PLT-Datei
    !PltObj = DLGPltObj.GetText()                              | Name des Layers
    !Blatt   = DLGBlatt.GetName()                              | Name des Blattschnittes
    Schrift1 = DLGSchrift1.GetNumber() 
    Schrift2 = DLGSchrift2.GetNumber()
  Weiter
zurck Ret
Ende Funktion
*
HILFE TEXT Allgemein
' '
' Mit diesem CARDSkript erstellen Sie eine Lageplanzeichnung  '
' fr Punkte der Punktedatenbank. '
' '
' Sie knnen zwischen allen und markierten Punkten whlen.'
' '
' Fr die Darstellung knnen Sie ein Symbol auswhlen. '
' '
' Punktnummer und Punkthhen knnen als Texte angeschrieben werden.'
' '
' Fr alle Daten knnen Sie einen Stift auswhlen. '
' '
' '
ENDE HILFE
